#!/bin/bash
#
# Simple script to stop an Amanda task
# kovacs.zoltan@mimoza.hu 2005-02-03

# Getting parameters

taskuser=$1	 # User running Amanda task to kill
task2kill=$2	 # Task to kill

# Some constants

amanda_sbin="/usr/sbin"
runuser=`whoami` # User running this script
sleeptime=3	 # Time to wait (in seconds) after killing a type of process

# Running as appropriate user and specifying task to kill is necessary

if [ ! -z "$2" -a "$runuser" = "$taskuser" ] ; then

# This task is running? Do amcheck to check it

    if [ ! -z "`$amanda_sbin/amcheck $task2kill | grep amcleanup`" ] ; then

# Enunerating Amanda processes of this task

        for process in 'amdump' 'driver' 'dumper' 'taper' ;
	do

# Getting PIDs for running process instances from process list and kill them

        	ps aux | grep $taskuser | grep $task2kill |grep $process |awk '{ print $2 }' | while read pid2kill 
    	    do
	        echo -n killing $task2kill $process $pid2kill
		kill $pid2kill
		echo " - done"
    	    done
	    sleep $sleeptime
	done

# OK, let's clean up, then check it (again)

        $amanda_sbin/amcleanup $task2kill
	$amanda_sbin/amcheck $task2kill
    fi

# Usage reminder

else
    echo Usage: $0 Username_running_Amanda_task Amanda_task_name
    if [ "$runuser" != "$taskuser" ]; then
        echo Please run as $taskuser.
    fi
    echo 
fi
